unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, StrUtils, LCLType, LazUTF8;

type

  { TForm1 }

  TForm1 = class(TForm)
    bong_proc: TEdit;
    terminator_answer: TEdit;
    termtext: TLabel;
    stop: TButton;
    frage: TPanel;
    start: TButton;
    qshow: TTimer;
    ent_ans: TTimer;
    check: TTimer;
    bong_timer: TTimer;
    aux: TTimer;
    // panel1: tpanel; //debug

    procedure auxTimer(Sender: TObject);
    procedure bong_timerTimer(Sender: TObject);
    procedure checkTimer(Sender: TObject);
    procedure ent_ansTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure qshowTimer(Sender: TObject);
    procedure startClick(Sender: TObject);
    procedure stopClick(Sender: TObject);
    procedure terminator_answerKeyPress(Sender: TObject; var Key: char);

  private
    { private declarations }
  public
    { public declarations }
  end;

type
  TEdit = class(StdCtrls.TEdit)
    // procedure click; override;
  end;

type
  TPanel = class(ExtCtrls.Tpanel)
    // public
    procedure click; override;
  end;

type
  TButton = class(StdCtrls.TButton)
    procedure click; override;
  end;

type
  Tigrok = record
    sgor, nesgor: integer;
    active: boolean;
    Name: string[255];
  end;

type
  q = record
    tekst: string;
    otvet: array [1..11] of string;
    vern: byte;
  end;

type
  term = record
    tekst, otvet: string;
    has_been: boolean;
  end;
  type
    TTermStage = (No, Rnd, Otvet, RR);


const
  dough: array [1..10] of integer =
    (3000, 9000, 15000, 30000, 90000, 150000, 300000, 900000, 1500000, 3000000);
  term_pinigai: array [1..4] of integer = (4000, 16000, 80000, 400000);

var
  Form1: TForm1;
  curr_q: integer;
  igrok: array [1..5] of TIgrok;
  isterm: boolean;
  baza: array [1..11] of Text;
  bazaterm: Text;
  imena: array [1..5] of TEdit;
  curr_money: array [1..5] of TLabel;
  b, c, d, e, f: integer;
  domande: array [1..10, 1..80] of q;
  _term: array [1..80] of term;
  variant: array [1..11] of TPanel;
  golosa: array [1..11] of TLabel;
  kolvo_golosov: array [1..11] of integer;
  otvechaet: byte;
  canvote, canstab: array [1..5] of boolean;
  bong_button: array [1..3] of TButton;
  max: integer;
  max_ans, richest_player: byte;
  NumberOfMax, numberofrich: byte;
  accepted: byte;
  mostmoney: integer;
  vote: array [1..5] of byte;
  // domande:array of array of q;
  help: string;
  aim: integer;
  bong: array of integer;
  bong_length: byte;
  foo: array of integer;
  h, i, j, k, l, m, n, o, p, r, _nomer, s, t, u, w, x,y,z: integer;
  found: boolean;
  stopped: array [1..5] of boolean;
  termplayer: array [1..2] of byte;
  stage: TTermStage;
  challenge: array [1..5] of tbutton;
  buzzer: array [1..2] of tpanel;
  termwas: boolean;
  term_vernoli:boolean;
  winrar, loser:byte;

implementation

{$R *.lfm}

{ TForm1 }
{ TPanel }


procedure TForm1.FormCreate(Sender: TObject);
var
  a: integer;
begin
    curr_q := 0;    //debug
  isterm := False;
  for a := 1 to 3 do
    bong_button[a] := TButton.Create(form1);
  for a := 1 to 5 do
  begin
    stopped[a]:=false;
    imena[a] := tedit.Create(form1);
    with imena[a] do
    begin
      Text := 'Игрок ' + IntToStr(a);
      parent := form1;
      Visible := True;
      left := 20;
      Width := 138;
      Height := 23;
      top := 10 + (a * 29);
      tag := a;
    end;
  end;
  for a := 1 to 10 do
  begin
    assignfile(baza[a], 'q' + IntToStr(a) + '.txt');
  end;
  for a:=1 to 5 do
  begin
    challenge[a]:=tbutton.create(form1);
  end;
  assignfile(bazaterm, 'qt.txt');
  termwas:=false;
   for a:=1 to 2 do
     begin
       buzzer[a]:=tpanel.create(form1);
     end;


end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  if (stage = otvet) then
  begin

    case key of
     65: begin    //A
       z:=1;
         terminator_answer.show;
  terminator_answer.setfocus;
       buzzer[1].color:=$007FFF00;
        form1.caption:=igrok[termplayer[z]].name+', введите ответ. Для фиксации нажмите Enter';
     end;
     76: begin     //L
        z:=2;
          terminator_answer.show;
  terminator_answer.setfocus;
        buzzer[2].color:=$007fff00;
         form1.caption:=igrok[termplayer[z]].name+', введите ответ. Для фиксации нажмите Enter';
     end;
    end;

  end;
end;

procedure bong_game(g: integer);
begin

end;

procedure TForm1.ent_ansTimer(Sender: TObject);
begin
  repeat
    ent_ans.tag := ent_ans.Tag + 1;

  until ((igrok[ent_ans.Tag].active) and (canvote[ent_ans.Tag])) or (ent_ans.Tag > 5);
  if (ent_ans.tag <= 5) then
  begin
    ent_ans.Enabled := False;
    ShowMessage('Игрок ' + igrok[ent_ans.tag].Name + ', голосуйте!'); //nujno
  end
  else
  begin
    ent_ans.Enabled := False;
    ent_ans.Tag := 6;
    max := 0;
    Numberofmax := 0;
    max_ans := 0;
    for b := 1 to (curr_q + 1) do
    begin
      if (kolvo_golosov[b] > max) then
      begin
        max_ans := b;
        max := kolvo_golosov[b];
      end;
    end;
    for b := 1 to (curr_q + 1) do
    begin
      if (kolvo_golosov[b] = max) then
      begin
        if (kolvo_golosov[b] = max) then
          Inc(numberofmax);
      end;
    end;
    numberofrich := 0;
    richest_player := 0;
    mostmoney := 0;
    for b := 1 to 5 do
    begin
      if (igrok[b].active) then
      begin
        numberofrich := 0;
        richest_player := b;
        mostmoney := igrok[b].sgor + igrok[b].nesgor;
        break;
      end;

    end;


    for b := 1 to 5 do
    begin
      if (igrok[b].active) and (igrok[b].sgor + igrok[b].nesgor > mostmoney) then
      begin
        richest_player := b;
        mostmoney := igrok[b].sgor + igrok[b].nesgor;
      end;

    end;
    for b := 1 to 5 do
    begin
      if (igrok[b].active) and (igrok[b].sgor + igrok[b].nesgor = mostmoney) then
      begin
        Inc(numberofrich);
      end;
    end;

    //  showmessage ('Лидер голосования - '+domande[curr_q, d].otvet[max_ans]+', индекс - '+inttostr(max_ans)+', повторений: '+inttostr(numberofmax)+#13+'Самый богатый игрок из оставшихся - '+igrok[richest_player].Name+'. Он голосовал за вариант '+domande[curr_q, d].otvet[vote[richest_player]]+'. Самых богатых игроков: '+inttostr(numberofrich));
    if (numberofmax = 1) then
    begin
      accepted := max_ans;
    end
    else if (numberofrich = 1) then
    begin
      accepted := vote[richest_player];
    end
    else
    begin
      randomize;
      repeat
        accepted := random(curr_q + 1) + 1;
      until accepted = max_ans;
    end;
    ShowMessage('Ответ принят - ' + domande[curr_q, d].otvet[max_ans]);  //nujno
    check.tag := curr_q;
    check.Enabled := True;
    variant[max_ans].Color := clYellow;
    check.Enabled := True;
  end;
end;

procedure TForm1.checkTimer(Sender: TObject);
label
  stab_impossible,
  terminator;
begin
  check.Enabled := False;
  variant[domande[curr_q, d].vern].color := clmoneygreen;
 if (accepted = domande[curr_q, d].vern) then
    begin
      showmessage('Верно!');
      e:=0;
      for b:=1 to 5 do
        begin
          if (igrok[b].active) then inc(e);
        end;
      for b:=1 to 5 do
        begin
          curr_money[b].parent:=form1;
          if (igrok[b].active) then  begin inc(igrok[b].sgor, dough[curr_q] div e); end;
                curr_money[b].caption := (IntToStr(igrok[b].sgor) + ' + ' + IntToStr(igrok[b].nesgor) + ' = ' + IntToStr(igrok[b].sgor + igrok[b].nesgor));
        end;
      for b:=1 to 5 do
        begin
          help:=(igrok[b].name);
         if (igrok[b].active) then
            begin
            stab_impossible:case QuestionDlg(help, 'Что вы будете делать?',mtCustom,[mrCancel, 'Продолжить игру', mrNo, 'Взять деньги', mrYes, 'Стабилизировать'],0) of
             mrCancel:;
             mrNo: begin
              igrok[b].active:=false;
              imena[b].Enabled:=false;
              curr_money[b].Enabled:=false;
                   end;
             mrYes: if (canstab[b]=false) then
                begin
                 showmessage('Вы уже использовали стабилизацию!');
                 goto stab_impossible;
                end
             else begin
              igrok[b].nesgor:=igrok[b].nesgor+(igrok[b].sgor div 2);
              igrok[b].sgor:=igrok[b].sgor div 2;
              curr_money[b].caption := (IntToStr(igrok[b].sgor) + ' + ' + IntToStr(igrok[b].nesgor) + ' = ' + IntToStr(igrok[b].sgor + igrok[b].nesgor));
              canstab[b]:=false;



             end;
            end;

        end;
    end;
      e:=0;
      for b:=1 to 5 do
        begin
          if (igrok[b].active) then inc(e);
        end;
      if (e>0) and (curr_q < 10) then begin
        inc(curr_q);

        if (e > 1) and ((curr_q=3) or (curr_q=5) or (Curr_q=7) or (curr_q=9)) and (isterm=false) then
           begin
             isterm:=true;
             stage:=rnd;
             showmessage('Терминатор!');
             frage.hide;
             for k:=1 to 11 do
               begin
                variant[k].hide;
                golosa[k].hide;
               end;
             for k:=1 to 1000 do
               begin
                 repeat
                   s:=random(5)+1;
                   until (igrok[s].active);
                   form1.caption:=igrok[s].name;
                end;
             case QuestionDlg (igrok[s].name, 'будете ли вы играть в терминатор?', mtcustom, [mrYes, 'Да', mrNo, 'Нет'], 0) of
              mrYes: begin
              inc (igrok[s].nesgor, term_pinigai[(curr_q-1) div 2]); //перенести
               curr_money[s].caption := (IntToStr(igrok[s].sgor) + ' + ' + IntToStr(igrok[s].nesgor) + ' = ' + IntToStr(igrok[s].sgor + igrok[s].nesgor));
               termplayer[1]:=s;
                 form1.caption:=igrok[s].name+', с кем вы будете играть?';
                  for t:= 1 to 5 do
                    begin
                      with challenge[t] do
                                        begin
                                          parent:=form1;
                                          visible:=true;
                                          left:=50+150*(t-1);
                                          width:= 125;
                                          height:=40;
                                          top:=333;
                                           caption:=igrok[t].name;
                                           tag:=10+t;
                                           if ((igrok[t].active=false) or (termplayer[1]=t))  then hide;
                                        end;
                    end;
             end;
              mrNo, mrCancel:begin
                isterm:=false;
                goto terminator;
              end;

             end;

      end;
       terminator:if (isterm=false) then qshow.enabled:=true;
      end
      else if (curr_q = 10) then begin
        showmessage('Вы успешно прошли игру!');
        halt;
      end
      else begin
       showmessage ('Все игроки забрали деньги');
       halt;
      end;

    end
 else
  begin
    ShowMessage('Вы ошиблись!');
    frage.hide;
    for b := 1 to 11 do
      begin
        variant[b].Hide;
      golosa[b].hide;
      end;
    for b := 1 to 3 do
    begin
      with bong_button[b] do
      begin
        parent := form1;
        Visible := True;
        left := 335 + 90 * (b - 1);
        Width := 80;
        Height := 49;
        top := 4;
        Caption := IntToStr(b);
        tag := b;
      end;
    end;
   // aux.tag:=1;
     //aux.enabled:=true;
               bong_timer.tag:=0;
        //  aux.enabled:=false;

                randomize;
          i := random(3) + 1; //nujno
          //i:=1;
          _nomer:=0;
          repeat
            inc (_nomer);
          until ((igrok[_nomer].active) and (igrok[_nomer].sgor > 0)) ;
          aim := igrok[_nomer].sgor;

          form1.caption:=(igrok[_nomer].Name + ', выберите вариант гонг-игры');
          form1.check.enabled:=false;
          //form1.aux.enabled:=false;
          for h := 1 to 3 do
            bong_button[h].Enabled := True;
          randomize;

          j := random ((aim div 5) - (aim div 25))+ 1 + aim div 25;
          m:= random(aim div j) +1;

         // foo:=copy (bong, 0, j);

          //showmessage (inttostr(k)); //debug





  end;
 end;


procedure TForm1.bong_timerTimer(Sender: TObject);
label bypass;
begin
  bong_timer.tag:=bong_timer.tag+1;
  if (bong_timer.tag<=m) then
    begin
      bong_proc.Text:=inttostr((strtoint(bong_proc.text))+j);
      stop.Enabled:=true;
    end
  else if (i = e) //если вариант беспроигрышный
  then
    begin
      bong_timer.enabled:=false;
      bong_proc.Text:=inttostr(aim);
      stop.caption:='Следующий игрок';
      bong_timer.tag:=0;
            igrok[_nomer].active:=false;
      curr_money[_nomer].enabled:=false;
      imena[_nomer].Enabled:=false;
              igrok[_nomer].sgor:=aim;
        curr_money[_nomer].caption := (IntToStr(igrok[_nomer].sgor) + ' + ' + IntToStr(igrok[_nomer].nesgor) + ' = ' + IntToStr(igrok[_nomer].sgor + igrok[_nomer].nesgor));
      if (_nomer<5) then
      begin
        repeat
        inc(_nomer);
        until (igrok[_nomer].active) or (_nomer>5);
        if (_nomer>5) then goto bypass;
        form1.caption:=(igrok[_nomer].Name + ', выберите вариант гонг-игры');
        for b:=1 to 3 do bong_button[b].Enabled:=true;
        i:=random(3)+1;
      end
      else begin
        showmessage ('Игра окончена');
        halt;
      end;


    end
  else
  begin
    bong_timer.enabled:=false;
    bong_proc.Text:='ГОНГ';
          stop.caption:='Следующий игрок';
       bong_timer.tag:=0;
             igrok[_nomer].active:=false;
      curr_money[_nomer].enabled:=false;
      imena[_nomer].Enabled:=false;

      igrok[_nomer].sgor:=0;
      curr_money[_nomer].caption := (IntToStr(igrok[_nomer].sgor) + ' + ' + IntToStr(igrok[_nomer].nesgor) + ' = ' + IntToStr(igrok[_nomer].sgor + igrok[_nomer].nesgor));
      if (_nomer<5) then
       begin
                  repeat
          inc(_nomer);
         until (igrok[_nomer].active) or (_nomer>5);
         if (_nomer>5) then goto bypass;
         //inc(_nomer);
         form1.caption:=(igrok[_nomer].Name + ', выберите вариант гонг-игры');
        for b:=1 to 3 do bong_button[b].Enabled:=true;
        i:=random(3)+1;
       end
             else begin
        bypass: showmessage ('Игра окончена');
        halt;
      end;
  end;


end;



procedure TForm1.auxTimer(Sender: TObject);
begin
 { if (aux.tag=0) then begin aux.tag:=1; end;
  stop.Enabled:=true;
  aux.tag:=aux.tag+1;
 bong_timer.tag:=0;
            aim := igrok[form1.aux.Tag].sgor;
          form1.caption:=(igrok[form1.aux.Tag].Name + ', выберите вариант гонг-игры');
          i := random(3) + 1;         //беспроигрышный вариант гонг-игры
          form1.check.enabled:=false;
          form1.aux.enabled:=false;
          for h := 1 to 3 do
            begin bong_button[h].Enabled := True; end;
          writeln('bong timer = ',form1.bong_timer.tag,'. aux = ',form1.aux.tag);
          randomize;

          j := random ((aim div 5) - (aim div 25))+ 1 + aim div 25;
          m:= random(aim div j) +1;

  while ((aux.Tag<5) and (igrok[aux.tag].active=false) and (stopped[aux.tag]=false) ) do begin {aux.tag:=aux.tag+1;}  end;
  aux.enabled:=false;
 // bong_timer.tag:=bong_timer.tag+1;
  if (aux.Tag <= 5) then
   // aux.tag:=aux.tag+1;
   // Form1.caption:=inttostr(aux.tag);//debug

    bong_timer.enabled:=true;                                   //debug   }

  end;


procedure TForm1.qshowTimer(Sender: TObject);
begin
  qshow.Enabled := False;
  //showmessage (inttostr(curr_q));
  reset(baza[curr_q]);  //nujno
  c := 0;
  //otvechaet:=0;
  for b := 1 to 5 do
  begin
    vote[b] := 0;
    if (igrok[b].active) then
     begin
      canvote[b] := True;
      imena[b].enabled:=true;
     end
    else
      canvote[b] := False;
  end;
  // canvote[1]:=false;//отладочная инфа
  //igrok[4].active:=false; //отладка
  // canvote[4]:=false;//отладочная инфа
  for b := 1 to 11 do
    kolvo_golosov[b] := 0;
  while not EOF(baza[curr_q]) do
  begin
    readln(baza[curr_q]);
    Inc(c);
  end;
  reset(baza[curr_q]);
  c := c div (curr_q + 3);


  //   setlength(_1, c);


  for b := 1 to c do
    with domande[curr_q, b] do
    begin
      readln(baza[curr_q], tekst);
      for d := 1 to (curr_q + 1) do

      begin
        readln(baza[curr_q], otvet[d]);
      end;
      readln(baza[curr_q], vern);
    end;

  closefile(baza[curr_q]);
  randomize;
  d := random(c) + 1;
  with frage do
  begin
    Show;

    Caption := domande[curr_q, d].tekst;

  end;

  for b := 1 to (curr_q + 1) do
  begin
    with variant[b] do
    begin
      parent := Form1;
      Visible := True;
      left := 335;
      Height := 40;
      Width := 290;
      top := 17 + (43 * b);
      Caption := domande[curr_q, d].otvet[b];
      tag := b;
      color := cldefault;
    end;
    with golosa[b] do
    begin
      parent := form1;
      Visible := True;
      left := 632;
      Height := variant[b].Height;
      Width := 85;
      top := variant[b].top + (variant[b].Height div 2);
      tag := b;
      Text := IntToStr(kolvo_golosov[b]);
    end;
  end;
  ent_ans.tag := 0;
  ent_ans.Enabled := True;
end;





procedure TForm1.startClick(Sender: TObject);
begin
  //form1.caption:='';     //debug
  curr_q := 1;   //debug curr_q :=1;

  start.hide;
  //QuestionDlg('dummy', 'Что вы будете делать?',mtCustom,[mrYes, 'Продолжить игру', mrNo, 'Взять деньги', mrCancel, 'Стабилизировать'],0);                            //debug
  for b := 1 to 5 do
  begin
    imena[b].ReadOnly := True;
    canstab[b] := True;
    with igrok[b] do
    begin
      sgor := 600;
      nesgor := 0;
      active := True;
      Name := imena[b].Text;
      //   load(curr_q);
      //form1.Caption:=form1.caption+imena[b].text+', ';  //debug
    end;
    curr_money[b] := tlabel.Create(form1);
    with curr_money[b] do
    begin
      parent := form1;
      Visible := True;
      left := 160;
      top := 13 + (b * 29);
      Text := (IntToStr(igrok[b].sgor) + ' + ' + IntToStr(igrok[b].nesgor) +
        ' = ' + IntToStr(igrok[b].sgor + igrok[b].nesgor));

    end;

  end;
  for b := 1 to 11 do
  begin
    variant[b] := tpanel.Create(form1);
    golosa[b] := tlabel.Create(form1);
    variant[b].tag := b;
    golosa[b].tag := b;
  end;
  qshow.Enabled := True;

end;

procedure TForm1.stopClick(Sender: TObject);
label ptn_grj;
begin
  {if (stop.caption = 'СТОП') then    }
    begin
     bong_timer.enabled:=false;
     //bong_timer.tag:=(bong_timer.tag)+1;
     igrok[_nomer].sgor:=strtoint(bong_proc.Text);
      curr_money[_nomer].caption := (IntToStr(igrok[_nomer].sgor) + ' + ' + IntToStr(igrok[_nomer].nesgor) + ' = ' + IntToStr(igrok[_nomer].sgor + igrok[_nomer].nesgor));
      igrok[_nomer].active:=false;
      curr_money[_nomer].enabled:=false;
      imena[_nomer].Enabled:=false;
      for b:= 1 to 3 do bong_button[b].Enabled:=true;
      if (_nomer<5) then
      begin
         repeat
          inc(_nomer);
         until ((igrok[_nomer].active) and (igrok[_nomer].sgor > 0)) or (_nomer>5);
         if (_nomer>5) then goto ptn_grj;

        form1.caption:=(igrok[_nomer].Name + ', выберите вариант гонг-игры');
        i:=random(3)+1;
      end
      else begin
       ptn_grj: showmessage ('Игра окончена');
        halt;
      end;
    end;

end;

procedure TForm1.terminator_answerKeyPress(Sender: TObject; var Key: char);
begin
  if (Key = #13) then
  begin
   help:=terminator_Answer.Text;
   buzzer[1].color:=cldefault;
   buzzer[2].color:=cldefault;
   buzzer[1].hide;
   buzzer[2].hide;
   termtext.hide;
   terminator_answer.text:='';
   terminator_answer.hide;
   if(utf8lowercase(help)=utf8lowercase(_term[d].otvet)) then
     begin
      showmessage('Верно!');
      term_vernoli:=true;
         if ( z = 1 ) then

           begin
           winrar:=termplayer[1];
           loser:=termplayer[2];

           end
         else if (z = 2) then
           begin
                 winrar:=termplayer[2];
           loser:=termplayer[1];
           end;
                    inc(igrok[winrar].sgor, igrok[loser].sgor);
           igrok[loser].sgor:=0;

           randomize;
            y:=random(5)+1;
            if (y <= (curr_q -1) div 2) then
              begin
               showmessage ('Игрок '+igrok[loser].name+' покидает игру');
               imena[loser].enabled:=false;
               igrok[loser].active:=false;
              end
            else begin
               showmessage ('Игрок '+igrok[loser].name+' остаётся в игре!');
            end;
     end
   else
   begin
      showmessage('Неверно! Правильный ответ - '+_term[d].otvet);
      term_vernoli:=false;
      if ( z = 1 ) then

           begin
           winrar:=termplayer[2];
           loser:=termplayer[1];

           end
         else if (z = 2) then
           begin
                 winrar:=termplayer[1];
           loser:=termplayer[2];
           end;
                    inc(igrok[winrar].sgor, igrok[loser].sgor);
           igrok[loser].sgor:=0;

           randomize;
            y:=random(5)+1;
            if (y <= (curr_q -1) div 2) then
              begin
               showmessage ('Игрок '+igrok[loser].name+' покидает игру');
               imena[loser].enabled:=false;
               igrok[loser].active:=false;
               curr_money[loser].enabled:=false;
              end
            else begin
               showmessage ('Игрок '+igrok[loser].name+' остаётся в игре!');
            end;
   end;
   for b:=1 to 5 do
   BEGIN
    curr_money[b].caption := (IntToStr(igrok[b].sgor) + ' + ' + IntToStr(igrok[b].nesgor) + ' = ' + IntToStr(igrok[b].sgor + igrok[b].nesgor));
   end;
   stage:=no;
   isterm:=false;
   qshow.enabled:=true;
  end;

end;



procedure TPANEL.click;
begin
  inherited;
  if (form1.ent_ans.Tag <= 5) and (canvote[form1.ent_ans.Tag]) then
  begin
    vote[form1.ent_ans.tag] := tag;
    kolvo_golosov[tag] := kolvo_golosov[tag] + igrok[form1.ent_ans.tag].sgor +
      igrok[form1.ent_ans.tag].nesgor;
    golosa[tag].Caption := IntToStr(kolvo_golosov[tag]);
    //vote
    canvote[form1.ent_ans.Tag] := False;
    form1.ent_ans.Enabled := True;
  end;

end;

procedure TButton.click;
begin
  inherited;
  if (tag >= 1) and (Tag <= 3) then
  begin
    e := tag;
    form1.bong_proc.Visible := True;
    form1.bong_proc.enabled:=true;
    form1.stop.Visible := True;
    for b := 1 to 3 do
    begin
      bong_button[b].Enabled := False;
    end;
    aim := igrok[_nomer].sgor;
    form1.bong_timer.enabled:=true;
    j := random ((aim div 5) - (aim div 25))+ 1 + aim div 25;
          m:= random(aim div j) +1;
    form1.bong_timer.tag:=0;
    form1.bong_proc.Text:='0';

  end
  else if (tag>=11) and (tag<=15) then
  begin

     if (termwas = false) then
    begin
      reset (bazaterm);
      c:=0;
      while not eof(bazaterm) do
            begin
              readln (bazaterm);
              inc (c);
            end;
      reset(bazaterm);
      c:= c div 2;
      u:=c;
       for b:=1 to u do
           begin
             with _term[b] do begin

           readln (bazaterm, tekst);
           readln (bazaterm, otvet);
           has_been:=false;
           end;



    end;
   closefile(bazaterm);
   termwas:=true;
  end;
     randomize;
     termplayer[2]:=tag-10;
  repeat
   d:=random(u)+1;
  until _term[d].has_been=false;
  _term[d].has_been:=true;
  for b:=1 to 5 do
    begin
      challenge[b].Hide;
    end;
  form1.termtext.show;
   form1.termtext.caption:=_term[d].tekst;
//   writeln (d);
    for b:=1 to 2 do
      begin
       with buzzer[b] do
            begin
             parent:=form1;
             visible:=true;
             top:=250;
             left:=b*180;
            end;
      end;
   buzzer[1].caption:=igrok[termplayer[1]].name+' (A)';
   buzzer[2].caption:=igrok[termplayer[2]].name+' (L)';
   stage:=otvet;
   for b:=1 to 5 do imena[b].enabled:=false;

   form1.setfocus;
end;

end;



end.
